#include <stdio.h>
#include <signal.h>
#include <unistd.h>
#include <stdlib.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <string.h>
#include "marketfunc.h"

#define ORDER_DELAY 5
#define NB_ACTION_TYPE 1

int envoyerOrdre(struct order ordre);
int randomEntre (int min, int max);
struct compteRendu lireCompteRendu();
void afficherEtat(int argent, int actionPossede[], int actionOnServer[], int prixAction[]);


struct compteRendu{
	int type;
	int nbAction;
	int prix;
	int pidDest;
};



int main(int argc, char * argv[])
{
	// Stock le nombre d'action de chaqu type possedait
	int actionPossede[NB_ACTION_TYPE];
	// Stock le nombre d'action de chaque type presente sur le marche
	int actionOnServer[NB_ACTION_TYPE];
	// Stock le prix de chacune des action presente sur le marche
	int prixAction[NB_ACTION_TYPE];
	// Somme d'argent possadé par l'actor
	int argent;
	struct compteRendu cr;
	int pipe_marketServer;

	// ETAPE 1 : CREATION ET OUVERTURE DU TUBE pipe_clientPID + OUVERTURE DU TUBE pipe_marketServer
	char * nomPipe = malloc(sizeof(char) * 50);
	sprintf(nomPipe,"pipe_client_%d",getpid());

	printf("Début ouverture des pipes\n");

	if (mkfifo(nomPipe, 0644) < 0)
	{
		perror("Echec lors de la creation du tube nommé ...");
		exit(-1);
	}
	printf("mkfifo ok\n");
	sleep(1);
	
	// Ouverture de pipe_markerServer
	pipe_marketServer = open("pipe_marketServer", O_WRONLY);
	
	printf("Premier OK\n");
	

	printf("Fin ouverture des pipes\n");

	// ETAPE 2 : ENVOI DE L'ORDRE D'ENREGISTREMENT

	struct order ordre;
	ordre.type = OT_REGISTER;
	ordre.sender = getpid();

	printf("Ecriture de l'ordre d'enregistrement \n");
	write(pipe_marketServer, &ordre, sizeof(ordre));
	
	printf("write ok\n");
	cr = lireCompteRendu();

	printf("Voici mon compte rendu : \n nbAction = %i\n type = %i\n, prix1 = %i\n", cr.nbAction, cr.type, cr.prix);
	
	// ETAPE 3 : RECUPERER L'ETAT DU SERVEUR
	argent = 1000;
	actionPossede[cr.type] = 0;
	actionOnServer[cr.type] = cr.nbAction;
	prixAction[cr.type] = cr.prix;
	
	afficherEtat(argent, actionPossede, actionOnServer, prixAction);

	
	// Mettre a jour la quantité d'argent du client
	
	
	// ETAPE 5 : ENVOI ALEATOIRE D'ORDRE DE VENTE ET D'ACHAT
	while(1)
	{
		printf("Je passe dans la boucle\n");
		int ordre = randomEntre(0,1);
		switch(ordre)
		{
			case 1 : 
			{
				// On fait un buy
				printf("ACTOR[%d] : Je fait un BUY\n", getpid());
				// Preparation de l'ordre
				int r = randomEntre(1, 5);
				int prixMax = 150;
				printf("ACTOR[%d] : Je désire acheter %d actions au prix maximum de %d\n", getpid(), r, prixMax);
				if(r * prixMax < argent)
				{
					struct order ordreBuy;
					ordreBuy.type = OT_BUY;
					ordreBuy.sender = getpid();
					ordreBuy.val1 = r;
					ordreBuy.val2 = 150; // prix minimum de vente
				
					// Envoi de l'offre
					printf("ACTOR[%d] : J'envoi mon ordre au serveur\n", getpid());
					envoyerOrdre(ordreBuy);
				
					// Lire le cr
					cr = lireCompteRendu();	
				
					// Mettre a jour les informations d'etats
					argent -= cr.prix;
					actionOnServer[0] -= cr.nbAction;
					actionPossede[0] += cr.nbAction;
					// Envoyer un OT_REQUEST_PRICE
					struct order ordreRequest;
					ordreRequest.type = OT_REQUEST_PRICE;
					ordreRequest.sender = getpid();
					ordreRequest.val1 = 0;
					envoyerOrdre(ordreRequest);
					cr = lireCompteRendu();
					prixAction[0] = cr.prix;	
				}
				else
				{
					printf("ACTOR[%d] :Je n'ai pas assez d'argent pour acheter des actions\n", getpid());	
				}			
				printf("ACTOR[%d] : Fin de l'action BUY\n", getpid());				
				break;
			}
			
			case 0 : 
			{
				// On fait un sell
				printf("ACTOR[%d] : Je fait un SELL\n", getpid());
				int r = randomEntre(0, actionPossede[0]);
				printf("ACTOR[%d] : Je désire vendre %d actions au prix minimum de 0\n", getpid(), r);
				struct order ordre;
				ordre.type = OT_SELL;
				ordre.sender = getpid();
				ordre.val1 = r;
				ordre.val2 = 0; // prix minimum de vente
				
				// Envoi de l'offre
				printf("ACTOR[%d] : J'envoi mon ordre au serveur\n", getpid());
				envoyerOrdre(ordre);
				
				// Lire le cr
				cr = lireCompteRendu();	
				//printf("Voici le CR recu : Type = %d, nbAction = %d, prix = %d\n", cr.type, cr.nbAction, cr.prix);
				
				// Mettre a jour les informations d'etats
				argent += cr.prix;
				actionOnServer[0] += cr.nbAction;
				actionPossede[0] -= cr.nbAction;
				// Envoyer un OT_REQUEST_PRICE
				struct order ordreRequest2;
				ordreRequest2.type = OT_REQUEST_PRICE;
				ordreRequest2.sender = getpid();
				ordreRequest2.val1 = 0;
				envoyerOrdre(ordreRequest2);
				cr = lireCompteRendu();
				prixAction[0] = cr.prix;
				printf("ACTOR[%d] : FIn de l'action SELL\n", getpid());			
				
				break;
			}
		}
	    afficherEtat(argent, actionPossede, actionOnServer, prixAction);
		sleep(ORDER_DELAY);
	}
	return 0;
	
}

struct compteRendu lireCompteRendu()
{
	struct compteRendu cr;
	char * nomPipe = malloc(sizeof(char) * 50);
	sprintf(nomPipe,"pipe_client_%d", getpid());
	int tubeActor = open(nomPipe, O_RDONLY);
	read(tubeActor, &cr, sizeof(cr));
	close(tubeActor);
	return cr;
}

int envoyerOrdre(struct order ordre)
{
	int tube = open("pipe_marketServer", O_WRONLY);
	write(tube, &ordre, sizeof(ordre));
	close(tube);
	return 0;
}

int randomEntre (int min, int max)
{
	return (min + (rand () % (max-min+1)));
} 

void afficherEtat(int argent, int actionPossede[], int actionOnServer[], int prixAction[])
{
	printf("*** ETAT DU MARCHE \n");
	printf("*** Il y a %d type(s) d'action possible \n", NB_ACTION_TYPE);
	printf("*** Je possède actuellement %d € \n", argent);
	int i;
	for(i=0; i<NB_ACTION_TYPE; i++)
	{
		printf("*** Action de type %d ***\n", i);
		printf("*** Je possède actuellement %d action de type %d\n", actionPossede[i], i);
		printf("*** L'action de type %d vaut actuellement %d €\n", i, prixAction[i]);
	}
}
