#include <stdio.h>
#include <signal.h>
#include <unistd.h>
#include <stdlib.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <string.h>
#include "marketfunc.h"

#define NB_ACTION_TYPE 1

int envoyerOrdre(struct order ordre);
struct compteRendu lireCompteRendu();
void afficherEtat(int argent, int actionPossede[], int actionOnServer[], int prixAction[]);



struct compteRendu{
	int type;
	int nbAction;
	int prix;
	int pidDest;
};

void alarmeHauteHandler(int a)
{
	printf("\n\n\n********* ALARME HAUTE DETECTEE !! ***********\n\n\n");
}

void alarmeBasseHandler(int a)
{
	printf("\n\n\n********* ALARME BASSE DETECTEE !! ***********\n\n\n");
}


int main(int argc, char * argv[])
{
	// Stock le nombre d'action de chaqu type possedait
	int actionPossede[NB_ACTION_TYPE];
	// Stock le nombre d'action de chaque type presente sur le marche
	int actionOnServer[NB_ACTION_TYPE];
	// Stock le prix de chacune des action presente sur le marche
	int prixAction[NB_ACTION_TYPE];
	// Somme d'argent possadé par l'actor
	int argent;
	struct compteRendu cr;
	int pipe_marketServer;


	signal(SIGUSR1, alarmeHauteHandler);
	signal(SIGUSR2, alarmeBasseHandler);		
	
	// ETAPE 1 : CREATION ET OUVERTURE DU TUBE pipe_clientPID + OUVERTURE DU TUBE pipe_marketServer
	char * nomPipe = malloc(sizeof(char) * 50);
	sprintf(nomPipe,"pipe_client_%d",getpid());

	printf("Début ouverture des pipes\n");

	if (mkfifo(nomPipe, 0644) < 0)
	{
		perror("Echec lors de la creation du tube nommé ...");
		exit(-1);
	}
	printf("mkfifo ok\n");
	sleep(1);
	
	// Ouverture de pipe_markerServer
	pipe_marketServer = open("pipe_marketServer", O_WRONLY);
	
	printf("Premier OK\n");
	

	printf("Fin ouverture des pipes\n");

	// ETAPE 2 : ENVOI DE L'ORDRE D'ENREGISTREMENT

	struct order ordre;
	ordre.type = OT_REGISTER;
	ordre.sender = getpid();

	printf("Ecriture de l'ordre d'enregistrement \n");
	write(pipe_marketServer, &ordre, sizeof(ordre));
	
	printf("write ok\n");
	cr = lireCompteRendu();

	printf("Voici mon compte rendu : \n nbAction = %i\n type = %i\n, prix1 = %i\n", cr.nbAction, cr.type, cr.prix);
	
	// ETAPE 3 : RECUPERER L'ETAT DU SERVEUR
	argent = 1000;
	actionPossede[cr.type] = 0;
	actionOnServer[cr.type] = cr.nbAction;
	prixAction[cr.type] = cr.prix;
	
	afficherEtat(argent, actionPossede, actionOnServer, prixAction);

	
	// Mettre a jour la quantité d'argent du client
	
	
	// ETAPE 5 : ENVOI MANUEL D'ORDRE AU SERVEUR

	int c = 1; 
	int res = 1; 
	
	while(c > 0)
	{ 
		printf("1.Acheter\n2.Vendre\n3.Lister prix\n4.Alarme Haute\n5.Alarme basse\n0.Quitter\n");
		res = scanf("%d",&c); 
		switch(c)
		{ 
			case 1:
			{
				// On fait un buy
				printf("ACTOR[%d] : Je fait un BUY\n", getpid());
				// Preparation de l'ordre
				printf("Acheter :\nNombre ?\n"); 
				res = scanf("%d",&c); 
				int r = c;
				printf("Acheter : Prix maximum ?\n"); 
				res = scanf("%d",&c); 
				int prixMax = c;
				printf("ACTOR[%d] : Je désire acheter %d actions au prix maximum de %d\n", getpid(), r, prixMax);
				if(r * prixMax < argent)
				{
					struct order ordreBuy;
					ordreBuy.type = OT_BUY;
					ordreBuy.sender = getpid();
					ordreBuy.val1 = r;
					ordreBuy.val2 = prixMax; // prix maximum de vente
				
					// Envoi de l'offre
					printf("ACTOR[%d] : J'envoi mon ordre au serveur\n", getpid());
					envoyerOrdre(ordreBuy);
				
					// Lire le cr
					cr = lireCompteRendu();	
				
					// Mettre a jour les informations d'etats
					argent -= cr.prix;
					actionOnServer[0] -= cr.nbAction;
					actionPossede[0] += cr.nbAction;
					// Envoyer un OT_REQUEST_PRICE
					struct order ordreRequest;
					ordreRequest.type = OT_REQUEST_PRICE;
					ordreRequest.sender = getpid();
					ordreRequest.val1 = 0;
					envoyerOrdre(ordreRequest);
					cr = lireCompteRendu();
					prixAction[0] = cr.prix;
				}
				break;
			} 
			case 2:
			{ 
				// On fait un sell
				printf("ACTOR[%d] : Je fait un SELL\n", getpid());
				printf("Vendre :\nNombre ?\n"); 
				res = scanf("%d",&c); 
				int nb = c;
				printf("Vendreeter : Prix minimum ?\n"); 
				res = scanf("%d",&c); 
				int prixMin = c;
				printf("ACTOR[%d] : Je désire vendre %d actions au prix minimum de %d\n", getpid(), nb, prixMin);
				struct order ordre;
				ordre.type = OT_SELL;
				ordre.sender = getpid();
				ordre.val1 = nb;
				ordre.val2 = prixMin; // prix minimum de vente
				
				// Envoi de l'offre
				printf("ACTOR[%d] : J'envoi mon ordre au serveur\n", getpid());
				envoyerOrdre(ordre);
				
				// Lire le cr
				cr = lireCompteRendu();	
				//printf("Voici le CR recu : Type = %d, nbAction = %d, prix = %d\n", cr.type, cr.nbAction, cr.prix);
				
				// Mettre a jour les informations d'etats
				argent += cr.prix;
				actionOnServer[0] += cr.nbAction;
				actionPossede[0] -= cr.nbAction;
				// Envoyer un OT_REQUEST_PRICE
				struct order ordreRequest2;
				ordreRequest2.type = OT_REQUEST_PRICE;
				ordreRequest2.sender = getpid();
				ordreRequest2.val1 = 0;
				envoyerOrdre(ordreRequest2);
				cr = lireCompteRendu();
				prixAction[0] = cr.prix;
				printf("ACTOR[%d] : FIn de l'action SELL\n", getpid());			
				
				break;
			} 
			case 3:
			{ 
				// Envoyer un OT_REQUEST_PRICE
				struct order ordreRequest;
				ordreRequest.type = OT_REQUEST_PRICE;
				ordreRequest.sender = getpid();
				ordreRequest.val1 = 0;
				envoyerOrdre(ordreRequest);
				cr = lireCompteRendu();
				printf("Liste des actions : \n");
				printf("Action de type 0 : %d\n", cr.prix);
				
				prixAction[0] = cr.prix;
				printf("ACTOR[%d] : FIn de l'action SELL\n", getpid());
				break; 
			} 
			case 4:
			{ 
				struct order alarmeHaute;
				alarmeHaute.type = OT_ALARM_HIGH;
				alarmeHaute.sender = getpid();
				printf("Alarme haute : seuil?\n"); 
				res = scanf("%d",&c); 
				int alarme = c;
				alarmeHaute.val1 = alarme;
				printf("ACTOR[%d] : Je place une alarme haute avec pour seuil %d\n", getpid(), alarme);
				envoyerOrdre(alarmeHaute);
				break; 
			} 
			case 5:
			{ 
				struct order alarmeBasse;
				alarmeBasse.type = OT_ALARM_HIGH;
				alarmeBasse.sender = getpid();
				printf("Alarme basse : seuil?\n"); 
				res = scanf("%d",&c); 
				int alarme = c;
				alarmeBasse.val1 = alarme;
				printf("ACTOR[%d] : Je place une alarme basse avec pour seuil %d\n", getpid(), alarme);
				envoyerOrdre(alarmeBasse);
				break; 
			} 
			default:
			{ 
				break; 
			}
		}
		afficherEtat(argent, actionPossede, actionOnServer, prixAction);
	}
	return 0;
}

struct compteRendu lireCompteRendu()
{
	struct compteRendu cr;
	char * nomPipe = malloc(sizeof(char) * 50);
	sprintf(nomPipe,"pipe_client_%d", getpid());
	int tubeActor = open(nomPipe, O_RDONLY);
	read(tubeActor, &cr, sizeof(cr));
	close(tubeActor);
	return cr;
}

int envoyerOrdre(struct order ordre)
{
	int tube = open("pipe_action0", O_WRONLY);
	write(tube, &ordre, sizeof(ordre));
	close(tube);
	return 0;
}

int randomEntre (int min, int max)
{
	return (min + (rand () % (max-min+1)));
} 

void afficherEtat(int argent, int actionPossede[], int actionOnServer[], int prixAction[])
{
	printf("*** ETAT DU MARCHE \n");
	printf("*** Il y a %d type(s) d'action possible \n", NB_ACTION_TYPE);
	printf("*** Je possède actuellement %d € \n", argent);
	int i;
	for(i=0; i<NB_ACTION_TYPE; i++)
	{
		printf("*** Action de type %d ***\n", i);
		printf("*** Je possède actuellement %d action de type %d\n", actionPossede[i], i);
		printf("*** L'action de type %d vaut actuellement %d €\n", i, prixAction[i]);
	}
}
